<?php

// ---------------------------------------------------------------------------------------------------------------------
// This file contains functions about Gnome specific operation.
// ---------------------------------------------------------------------------------------------------------------------


// Gnome ------------------------------------------------------------------------------------------

/** Get a list of files with the given emblems */
function getListsFromSystemEmblems($UserName, $Emblems) {

	$Files = array();
	if(!is_array($Emblems)) $Emblems = array($Emblems);

	foreach($Emblems as $Emblem) {
		// Grep file with keyword then grep the desired keyword
		$Cmd = 'rgrep -Ho -E "<file [^>]*>(<keyword [^>]*>)+</file>" $(ls) '
		    .'| rgrep -E "<keyword name=\"(user)?'.$Emblem.'[0-9]*\""';
		$CurDir = getcwd();
		chdir("/home/".$UserName."/.nautilus/metafiles");
		$Lines = split('file:%2F%2F', ''.shell_exec($Cmd));
		chdir($CurDir);

		// Extract the name of the file with that keywork
		foreach($Lines as $Line) {
			// Get the directory name
			$DirName  = urldecode(urldecode(substr($Line, 0, strpos($Line, ".xml"))));
			// Extract the file name and decode it
			$Temp     = split('.xml:<file name="', $Line);
			$FileName = $DirName.(strEndWith("/", $DirName)?"":"/").urldecode(urldecode(substr(($Temp[1]), 0, strpos(($Temp[1]), "\""))));
			// Validate the file
			if($FileName == "/") continue;

			// Ensure no repeat
			if(array_search($FileName, $Files)) continue;
			// Add the file into the set
			$Files[] = $FileName;
		}
	}

	return $Files;
}

?>
