import os, re, urllib

class Gnome:
	
	FileKeywordPattern = re.compile(r'^file:%2F%2F(.*)\.xml:<file name="([^\"]*)"');
	
	def getListsFromSystemEmblems(Gnome, UserName, Emblems):
		# Ensure that the emblems is a list
		if type(Emblems) != list: Emblems = [Emblems];
		# Save the current directory
		CWD       = os.getcwd();
		# Move to work in the Nautilus Metafiles folder
		os.chdir("/home/" + UserName + "/.nautilus/metafiles");
		# Loop to collect the file names
		Files = [];
		for Emblem in Emblems:
			# The first grep is to get the one with at least one "<keyword...>"
			# The second grep selects only the one with that enblem
			# This method is much faster than trying to do at one (I don't know why)
			Cmd = 'grep -Ho -E "<file [^>]*>(<keyword [^>]*>)+</file>" $(ls) | grep -E "<keyword name=\\"(user)?'+Emblem+'[0-9]*\\""';
			for Line in os.popen(Cmd).readlines():
				# Extract folder name and file name
				Values = Gnome.FileKeywordPattern.search(Line).groups();
				# Construct a full path with the double-unquoted folder name and the file name
				FullPath = urllib.unquote(urllib.unquote(Values[0])) + "/" + Values[1];
				# Eliminate the file/folder name with '//' that may occurs when the file is on the root
				if FullPath.startswith("//"): FullPath = FullPath[1:len(FullPath)];
				# Collect the full-path
				Files.append(FullPath);
		# Set the current working directory back
		os.chdir(CWD);
		# Return
		return Files
	getListsFromSystemEmblems = classmethod(getListsFromSystemEmblems);


