<?php require_once('Libs.inc'); ?>
<?php

// These are example sub-routine that may be used as pre- & post- backup script
$IsShowReminderForMountingDevice_Runned = false;

/** Utilities functions for reminding the user to hookup the backup device */
function showReminderForMountingDevice($BackupDIR) {
	global $IsShowReminderForMountingDevice_Runned;
	while(!file_exists($BackupDIR)) {
		if(!showConfirmDialog(
			"Time to backup!",
			"The target folder '$BackupDIR' is not seems to be mounted.".
			"Plug it or click 'Cancel' to skip this update.",
			600, 300
		  )) {
			echo "The backup is cancel by the user. Backup later then.\n";
			exit(0);
		}
	}
	$IsShowReminderForMountingDevice_Runned = true;
}

/** Utilities functions for reminding the user to hookup the backup device */
function showReminderForUnmountingDevice($BackupDIR) {
	global $IsShowReminderForMountingDevice_Runned;
	if($IsShowReminderForMountingDevice_Runned)
		showInfoGUI("Backup is done", "The backup is done. You may unplug the device.\n", 600, 300, 10);
}

?>
